#ifndef WLAN_H
#define WLAN_H

#include <ESP8266WiFi.h>
#include <PubSubClient.h>

void initial_connection(const char *ssid, const char *psk);
void connect_wlan(const char *ssid, const char *psk, const int max_retries,
                  const int sleep_time);
void connect_mqtt(PubSubClient &client, const char *mqtt_host,
                  const int mqtt_port, const char *mqtt_user,
                  const char *mqtt_password, const char *device_id,
                  const char *topic);
void disconnect_mqtt(PubSubClient &client, const char *topic);
size_t construct_json(float *data, char *buffer, int buffer_size);
void mqtt_transfer(PubSubClient &client, const char *mqtt_host,
                   const int mqtt_port, const char *mqtt_user,
                   const char *mqtt_password, const char *device_id,
                   const char *topic, float *data);
void enter_deep_sleep(bool wifi_timeout, int sleep_time);

#endif /* WLAN_H */
